import { IComponentDefinition, IBuildOptions, IComponentOptions } from "./ComponentComposer";
import { IClientLoadableResourceManifest, IClientLoadableManifestProvider, IResourceManifest, ILoadByUrlRule, IClientManifestLoadableByUrl, IElementSelectorRule, IClientManifestLoadableByElementRules } from "./LoadableManifestRegistry";
export declare class ComponentRegistration {
    componentOptions: IComponentOptions;
    manifestPath: string;
    manifest: IResourceManifest;
    buildOptions: IBuildOptions;
    definition: IComponentDefinition;
    loadByUrlRules: Array<ILoadByUrlRule>;
    loadByElementRules: Array<IElementSelectorRule>;
    constructor(componentOptions: IComponentOptions, manifestPath: string, manifest: IResourceManifest);
}
export interface IComponentClientManifest extends IClientLoadableResourceManifest, IClientManifestLoadableByUrl, IClientManifestLoadableByElementRules {
    /** The name for this component, this should be a none conflicting name
        e.g. use project as prefix myuniqueprojectname-componentName.
        i.e. <myuniqueprojectname-componentName></myuniqueprojectname-componentName> */
    elementName: string;
    definition: IComponentDefinition;
}
export declare class ComponentRegistry implements IClientLoadableManifestProvider {
    private static ComponentRegistrations;
    private static ComponentElements;
    static registerComponent: (manifest: IResourceManifest, componentOptions: IComponentOptions) => void;
    static addComponentDefinition: (manifest: IResourceManifest, definition: IComponentDefinition) => void;
    static addComponentBuildOptions: (manifest: IResourceManifest, buildOptions: IBuildOptions) => void;
    static loadByUrl: (manifest: IResourceManifest, loadRule: ILoadByUrlRule) => void;
    static loadByElementRule: (manifest: IResourceManifest, elementRule: IElementSelectorRule) => void;
    static getRegistrations: () => ComponentRegistration[];
    getClientLoadableManifests: (currentExtensionId: string) => IComponentClientManifest[];
    clearState: () => void;
    private static ensureCorrectManifest;
}
