import { IComponentOptions, IComponentComposer } from "./ComponentComposer";
import { IResourceDescription, IResourceComposer } from "./ResourceComposer";
import { IBlockingComposer } from "./BlockingComposer";
export interface IComposer {
    registerComponent: (componentOptions: IComponentOptions) => IComponentComposer;
    registerResource: (resourceDescription: IResourceDescription) => IResourceComposer;
}
export declare class Composer {
    /** Do not instantiate, use static members instead of constructor / new Composer().
        E.g. Composer.registerComponent()
    */
    private constructor();
    static registerManifest: (manifestId: string) => IComposer;
    static openResourceManifest: (manifestId: string) => IComposer;
    /** Add information about things you want to block.
        E.g. block a manifest from being loaded, so you can provide your own implementation
    */
    static readonly block: IBlockingComposer;
}
