import { ManifestType } from "./Enums";
export interface IClientManifest {
    manifestType: ManifestType;
}
export interface IClientManifestProvider {
    getClientManifests: (currentExtensionId: string) => Array<IClientManifest>;
    clearState: () => void;
}
export declare class StaticClientManifestProviderProxy implements IClientManifestProvider {
    private getClientManifestsFunc;
    private clearStateFunc;
    constructor(getClientManifestsFunc: (currentExtensionId: string) => Array<IClientManifest>, clearStateFunc: () => void);
    getClientManifests: (currentExtensionId: string) => IClientManifest[];
    clearState: () => void;
}
export declare class ManifestRegistry {
    private static CurrentManifestPath;
    private static ClientManifestProviders;
    static registerManifestProvider: (provider: IClientManifestProvider) => void;
    static setCurrentManifestPath: (manifestPath?: string) => void;
    static getCurrentManifestPath: () => string;
    static getClientManifests: (currentExtensionId: string) => IClientManifest[];
    static clearState: () => void;
}
