import { IClientLoadableResourceManifest, IClientLoadableManifestProvider, ILoadByUrlRule, IResourceManifest, IClientManifestLoadableByUrl } from "./LoadableManifestRegistry";
import { IResourceDescription, IOrderOptions } from "./ResourceComposer";
export interface IResourceClientManifest extends IClientLoadableResourceManifest, IClientManifestLoadableByUrl {
}
export declare class ResourceRegistry implements IClientLoadableManifestProvider {
    private static ResourceRegistrations;
    static registerResource: (manifest: IResourceManifest, resourceDescription: IResourceDescription) => void;
    static addOrdering: (manifest: IResourceManifest, orderOption: IOrderOptions) => void;
    static loadByUrl: (manifest: IResourceManifest, loadRule: ILoadByUrlRule) => void;
    static getRegisteredResourceBundles: (pathJoiner: (path1: any, path2: any) => string) => {
        [key: string]: string[];
    };
    getClientLoadableManifests: (currentExtensionId: string) => IResourceClientManifest[];
    clearState: () => void;
    private static ensureCorrectManifest;
}
